Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 1932)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 1933)
@@ -2501,5 +2530,5 @@
        IF ( myid == 0  .AND.  cpl_id == 1 )  THEN
 
-          message_string = 'pointer for array "' // TRIM( name ) //            &
+          message_string = 'pointer for array "' // TRIM( name ) //             &
                            '" can''t be associated'
           CALL message( 'pmci_set_array_pointer', 'PA0117', 3, 2, 0, 6, 0 )
@@ -2519,8 +2548,8 @@
 
     IF ( ASSOCIATED( p_3d ) )  THEN
-       CALL pmc_s_set_dataarray( client_id, p_3d, nz_cl, nz, &
+       CALL pmc_s_set_dataarray( child_id, p_3d, nz_cl, nz,                     &
                                  array_2 = p_3d_sec )
     ELSEIF ( ASSOCIATED( p_2d ) )  THEN
-       CALL pmc_s_set_dataarray( client_id, p_2d )
+       CALL pmc_s_set_dataarray( child_id, p_2d )
     ELSE
 !
@@ -2528,5 +2557,5 @@
        IF ( myid == 0  .AND.  cpl_id == 1 )  THEN
 
-          message_string = 'pointer for array "' // TRIM( name ) //            &
+          message_string = 'pointer for array "' // TRIM( name ) //             &
                            '" can''t be associated'
           CALL message( 'pmci_set_array_pointer', 'PA0117', 3, 2, 0, 6, 0 )
@@ -2545,5 +2574,5 @@
 
 
- SUBROUTINE pmci_create_client_arrays( name, is, ie, js, je, nzc  )
+ SUBROUTINE pmci_create_child_arrays( name, is, ie, js, je, nzc  )
 
     IMPLICIT NONE
@@ -2599,10 +2628,10 @@
     ELSE
 !
-!--    Give only one message for the first client domain
+!--    Give only one message for the first child domain
        IF ( myid == 0  .AND.  cpl_id == 2 )  THEN
 
-          message_string = 'pointer for array "' // TRIM( name ) //            &
+          message_string = 'pointer for array "' // TRIM( name ) //             &
                            '" can''t be associated'
-          CALL message( 'pmci_create_client_arrays', 'PA0170', 3, 2, 0, 6, 0 )
+          CALL message( 'pmci_create_child_arrays', 'PA0170', 3, 2, 0, 6, 0 )
        ELSE
 !
@@ -2613,31 +2642,37 @@
 
 #endif
- END SUBROUTINE pmci_create_client_arrays
-
-
-
- SUBROUTINE pmci_server_initialize
-!-- TO_DO: add general explanations about what this subroutine does
+ END SUBROUTINE pmci_create_child_arrays
+
+
+
+ SUBROUTINE pmci_parent_initialize
+
+!
+!-- Send data for the children in order to let them create initial 
+!-- conditions by interpolating the parent-domain fields.
 #if defined( __parallel )
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  client_id   !:
+    INTEGER(iwp) ::  child_id    !:
     INTEGER(iwp) ::  m           !:
 
-    REAL(wp) ::  waittime    !:
-
-
-    DO  m = 1, SIZE( pmc_server_for_client ) - 1
-       client_id = pmc_server_for_client(m)
-       CALL pmc_s_fillbuffer( client_id, waittime=waittime )
+    REAL(wp) ::  waittime        !:
+
+
+    DO  m = 1, SIZE( pmc_parent_for_child ) - 1
+       child_id = pmc_parent_for_child(m)
+       CALL pmc_s_fillbuffer( child_id, waittime=waittime )
     ENDDO
 
 #endif
- END SUBROUTINE pmci_server_initialize
-
-
-
- SUBROUTINE pmci_client_initialize
-!-- TO_DO: add general explanations about what this subroutine does
+ END SUBROUTINE pmci_parent_initialize
+
+
+
+ SUBROUTINE pmci_child_initialize
+
+!
+!-- Create initial conditions for the current child domain by interpolating 
+!-- the parent-domain fields.
 #if defined( __parallel )
     IMPLICIT NONE
@@ -2650,12 +2685,12 @@
     INTEGER(iwp) ::  jcs        !:
 
-    REAL(wp) ::  waittime   !:
-
-!
-!-- Root id is never a client
+    REAL(wp) ::  waittime       !:
+
+!
+!-- Root id is never a child
     IF ( cpl_id > 1 )  THEN
 
 !
-!--    Client domain boundaries in the server index space
+!--    Child domain boundaries in the parent index space
        icl = coarse_bound(1)
        icr = coarse_bound(2)
@@ -2664,23 +2699,23 @@
 
 !
-!--    Get data from server
+!--    Get data from the parent
        CALL pmc_c_getbuffer( waittime = waittime )
 
 !
 !--    The interpolation.
-       CALL pmci_interp_tril_all ( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo,   &
+       CALL pmci_interp_tril_all ( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo,    &
                                    r2yo, r1zo, r2zo, nzb_u_inner, 'u' )
-       CALL pmci_interp_tril_all ( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv,   &
+       CALL pmci_interp_tril_all ( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv,    &
                                    r2yv, r1zo, r2zo, nzb_v_inner, 'v' )
-       CALL pmci_interp_tril_all ( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo,   &
+       CALL pmci_interp_tril_all ( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo,    &
                                    r2yo, r1zw, r2zw, nzb_w_inner, 'w' )
-       CALL pmci_interp_tril_all ( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo,   &
+       CALL pmci_interp_tril_all ( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo,    &
                                    r2yo, r1zo, r2zo, nzb_s_inner, 'e' )
        IF ( .NOT. neutral )  THEN
-          CALL pmci_interp_tril_all ( pt, ptc, ico, jco, kco, r1xo, r2xo,      &
+          CALL pmci_interp_tril_all ( pt, ptc, ico, jco, kco, r1xo, r2xo,       &
                                       r1yo, r2yo, r1zo, r2zo, nzb_s_inner, 's' )
        ENDIF
        IF ( humidity  .OR.  passive_scalar )  THEN
-          CALL pmci_interp_tril_all ( q, qc, ico, jco, kco, r1xo, r2xo, r1yo,  &
+          CALL pmci_interp_tril_all ( q, qc, ico, jco, kco, r1xo, r2xo, r1yo,   &
                                       r2yo, r1zo, r2zo, nzb_s_inner, 's' )
        ENDIF
@@ -2710,8 +2745,8 @@
 
 
-    SUBROUTINE pmci_interp_tril_all( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y,    &
+    SUBROUTINE pmci_interp_tril_all( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y,     &
                                      r1z, r2z, kb, var )
 !
-!--    Interpolation of the internal values for the client-domain initialization
+!--    Interpolation of the internal values for the child-domain initialization
 !--    This subroutine is based on trilinear interpolation.
 !--    Coding based on interp_tril_lr/sn/t
@@ -2739,5 +2774,5 @@
 
        REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT) :: f !:
-       REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: fc    !:
+       REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: fc       !:
        REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN) :: r1x   !:
        REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN) :: r2x   !:
@@ -2762,27 +2797,28 @@
        jb = nys
        je = nyn
-       IF ( nest_bound_l )  THEN
-          ib = nxl - 1
-!
-!--       For u, nxl is a ghost node, but not for the other variables
-          IF ( var == 'u' )  THEN
-             ib = nxl
+       IF ( nesting_mode /= 'vertical' )  THEN
+          IF ( nest_bound_l )  THEN
+             ib = nxl - 1
+!
+!--          For u, nxl is a ghost node, but not for the other variables
+             IF ( var == 'u' )  THEN
+                ib = nxl
+             ENDIF
           ENDIF
-       ENDIF
-       IF ( nest_bound_s )  THEN
-          jb = nys - 1
-!
-!--       For v, nys is a ghost node, but not for the other variables
-          IF ( var == 'v' )  THEN
-             jb = nys
+          IF ( nest_bound_s )  THEN
+             jb = nys - 1
+!
+!--          For v, nys is a ghost node, but not for the other variables
+             IF ( var == 'v' )  THEN
+                jb = nys
+             ENDIF
           ENDIF
-       ENDIF
-       IF ( nest_bound_r )  THEN
-          ie = nxr + 1
-       ENDIF
-       IF ( nest_bound_n )  THEN
-          je = nyn + 1
-       ENDIF
-
+          IF ( nest_bound_r )  THEN
+             ie = nxr + 1
+          ENDIF
+          IF ( nest_bound_n )  THEN
+             je = nyn + 1
+          ENDIF
+       ENDIF
 !
 !--    Trilinear interpolation.
@@ -2828,5 +2864,6 @@
                 k = kb(j,i) + 1
                 DO  WHILE ( zu(k) < zuc1 )
-                   logratio = ( LOG( ( zu(k) - zu(kb(j,i)) ) / z0(j,i)) ) / logzuc1
+                   logratio = ( LOG( ( zu(k) - zu(kb(j,i)) ) / z0(j,i)) ) /     &
+                                logzuc1
                    f(k,j,i) = logratio * f(k1,j,i)
                    k  = k + 1
@@ -2849,5 +2886,5 @@
 
 #endif
- END SUBROUTINE pmci_client_initialize
+ END SUBROUTINE pmci_child_initialize
 
 
@@ -2855,6 +2892,6 @@
  SUBROUTINE pmci_check_setting_mismatches
 !
-!-- Check for mismatches between settings of master and client variables
-!-- (e.g., all clients have to follow the end_time settings of the root model).
+!-- Check for mismatches between settings of master and child variables
+!-- (e.g., all children have to follow the end_time settings of the root model).
 !-- The root model overwrites variables in the other models, so these variables
 !-- only need to be set once in file PARIN.
@@ -2862,5 +2899,5 @@
 #if defined( __parallel )
 
-    USE control_parameters,                                                    &
+    USE control_parameters,                                                     &
         ONLY:  dt_restart, end_time, message_string, restart_time, time_restart
 
@@ -2884,9 +2921,9 @@
     IF ( .NOT. pmc_is_rootmodel() )  THEN
        IF ( end_time /= end_time_root )  THEN
-          WRITE( message_string, * )  'mismatch between root model and ',      &
-               'client settings &   end_time(root) = ', end_time_root,         &
-               ' &   end_time(client) = ', end_time, ' & client value is set', &
+          WRITE( message_string, * )  'mismatch between root model and ',       &
+               'child settings &   end_time(root) = ', end_time_root,           &
+               ' &   end_time(child) = ', end_time, ' & child value is set',    &
                ' to root value'
-          CALL message( 'pmci_check_setting_mismatches', 'PA0419', 0, 1, 0, 6, &
+          CALL message( 'pmci_check_setting_mismatches', 'PA0419', 0, 1, 0, 6,  &
                         0 )
           end_time = end_time_root
@@ -2901,9 +2938,9 @@
     IF ( .NOT. pmc_is_rootmodel() )  THEN
        IF ( restart_time /= restart_time_root )  THEN
-          WRITE( message_string, * )  'mismatch between root model and ',      &
-               'client settings &   restart_time(root) = ', restart_time_root, &
-               ' &   restart_time(client) = ', restart_time, ' & client ',     &
+          WRITE( message_string, * )  'mismatch between root model and ',       &
+               'child settings &   restart_time(root) = ', restart_time_root,   &
+               ' &   restart_time(child) = ', restart_time, ' & child ',        &
                'value is set to root value'
-          CALL message( 'pmci_check_setting_mismatches', 'PA0419', 0, 1, 0, 6, &
+          CALL message( 'pmci_check_setting_mismatches', 'PA0419', 0, 1, 0, 6,  &
                         0 )
           restart_time = restart_time_root
@@ -2918,9 +2955,9 @@
     IF ( .NOT. pmc_is_rootmodel() )  THEN
        IF ( dt_restart /= dt_restart_root )  THEN
-          WRITE( message_string, * )  'mismatch between root model and ',      &
-               'client settings &   dt_restart(root) = ', dt_restart_root,     &
-               ' &   dt_restart(client) = ', dt_restart, ' & client ',         &
+          WRITE( message_string, * )  'mismatch between root model and ',       &
+               'child settings &   dt_restart(root) = ', dt_restart_root,       &
+               ' &   dt_restart(child) = ', dt_restart, ' & child ',            &
                'value is set to root value'
-          CALL message( 'pmci_check_setting_mismatches', 'PA0419', 0, 1, 0, 6, &
+          CALL message( 'pmci_check_setting_mismatches', 'PA0419', 0, 1, 0, 6,  &
                         0 )
           dt_restart = dt_restart_root
@@ -2935,9 +2972,9 @@
     IF ( .NOT. pmc_is_rootmodel() )  THEN
        IF ( time_restart /= time_restart_root )  THEN
-          WRITE( message_string, * )  'mismatch between root model and ',      &
-               'client settings &   time_restart(root) = ', time_restart_root, &
-               ' &   time_restart(client) = ', time_restart, ' & client ',     &
+          WRITE( message_string, * )  'mismatch between root model and ',       &
+               'child settings &   time_restart(root) = ', time_restart_root,   &
+               ' &   time_restart(child) = ', time_restart, ' & child ',        &
                'value is set to root value'
-          CALL message( 'pmci_check_setting_mismatches', 'PA0419', 0, 1, 0, 6, &
+          CALL message( 'pmci_check_setting_mismatches', 'PA0419', 0, 1, 0, 6,  &
                         0 )
           time_restart = time_restart_root
@@ -2953,5 +2990,4 @@
  SUBROUTINE pmci_ensure_nest_mass_conservation
 
-#if defined( __parallel )
 !
 !-- Adjust the volume-flow rate through the top boundary so that the net volume
@@ -2959,8 +2995,8 @@
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i                          !:
-    INTEGER(iwp) ::  ierr                       !:
-    INTEGER(iwp) ::  j                          !:
-    INTEGER(iwp) ::  k                          !:
+    INTEGER(iwp) ::  i                           !:
+    INTEGER(iwp) ::  ierr                        !:
+    INTEGER(iwp) ::  j                           !:
+    INTEGER(iwp) ::  k                           !:
 
     REAL(wp) ::  dxdy                            !:
@@ -2996,5 +3032,5 @@
 #if defined( __parallel )
     IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLREDUCE( volume_flow_l(1), volume_flow(1), 1, MPI_REAL, &
+    CALL MPI_ALLREDUCE( volume_flow_l(1), volume_flow(1), 1, MPI_REAL,          &
                         MPI_SUM, comm2d, ierr )
 #else
@@ -3029,5 +3065,5 @@
 #if defined( __parallel )
     IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLREDUCE( volume_flow_l(2), volume_flow(2), 1, MPI_REAL,         &
+    CALL MPI_ALLREDUCE( volume_flow_l(2), volume_flow(2), 1, MPI_REAL,          &
                         MPI_SUM, comm2d, ierr )
 #else
@@ -3049,5 +3085,5 @@
 #if defined( __parallel )
     IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLREDUCE( volume_flow_l(3), volume_flow(3), 1, MPI_REAL,         &
+    CALL MPI_ALLREDUCE( volume_flow_l(3), volume_flow(3), 1, MPI_REAL,          &
                         MPI_SUM, comm2d, ierr )
 #else
@@ -3066,5 +3102,4 @@
     ENDDO
 
-#endif
  END SUBROUTINE pmci_ensure_nest_mass_conservation
 
@@ -3101,13 +3136,13 @@
     IMPLICIT NONE
 
-    INTEGER(iwp),INTENT(IN) ::  swaplevel  !: swaplevel (1 or 2) of PALM's
-                                           !: timestep
-
-    INTEGER(iwp)            ::  client_id  !:
-    INTEGER(iwp)            ::  m          !:
-
-    DO  m = 1, SIZE( pmc_server_for_client )-1
-       client_id = pmc_server_for_client(m)
-       CALL pmc_s_set_active_data_array( client_id, swaplevel )
+    INTEGER(iwp), INTENT(IN) ::  swaplevel  !: swaplevel (1 or 2) of PALM's
+                                            !: timestep
+
+    INTEGER(iwp)            ::  child_id    !:
+    INTEGER(iwp)            ::  m           !:
+
+    DO  m = 1, SIZE( pmc_parent_for_child )-1
+       child_id = pmc_parent_for_child(m)
+       CALL pmc_s_set_active_data_array( child_id, swaplevel )
     ENDDO
 
@@ -3131,36 +3166,36 @@
     INTEGER(iwp)           ::  istat  !:
 
-    CHARACTER(LEN=*),INTENT(IN) ::  local_nesting_mode
-
-    IF ( local_nesting_mode == 'one-way' )  THEN
-
-       CALL pmci_client_datatrans( server_to_client )
-       CALL pmci_server_datatrans( server_to_client )
+    CHARACTER(LEN=*), INTENT(IN) ::  local_nesting_mode
+
+    IF ( TRIM( local_nesting_mode ) == 'one-way' )  THEN
+
+       CALL pmci_child_datatrans( parent_to_child )
+       CALL pmci_parent_datatrans( parent_to_child )
 
     ELSE
 
-       IF ( nesting_datatransfer_mode == 'cascade' )  THEN
-
-          CALL pmci_client_datatrans( server_to_client )
-          CALL pmci_server_datatrans( server_to_client )
-
-          CALL pmci_server_datatrans( client_to_server )
-          CALL pmci_client_datatrans( client_to_server )
-
-       ELSEIF ( nesting_datatransfer_mode == 'overlap' )  THEN
-
-          CALL pmci_server_datatrans( server_to_client )
-          CALL pmci_client_datatrans( server_to_client )
-
-          CALL pmci_client_datatrans( client_to_server )
-          CALL pmci_server_datatrans( client_to_server )
-
-       ELSEIF ( TRIM( nesting_datatransfer_mode ) == 'mixed' )  THEN
-
-          CALL pmci_server_datatrans( server_to_client )
-          CALL pmci_client_datatrans( server_to_client )
-
-          CALL pmci_server_datatrans( client_to_server )
-          CALL pmci_client_datatrans( client_to_server )
+       IF( nesting_datatransfer_mode == 'cascade' )  THEN
+
+          CALL pmci_child_datatrans( parent_to_child )
+          CALL pmci_parent_datatrans( parent_to_child )
+
+          CALL pmci_parent_datatrans( child_to_parent )
+          CALL pmci_child_datatrans( child_to_parent )
+
+       ELSEIF( nesting_datatransfer_mode == 'overlap')  THEN
+
+          CALL pmci_parent_datatrans( parent_to_child )
+          CALL pmci_child_datatrans( parent_to_child )
+
+          CALL pmci_child_datatrans( child_to_parent )
+          CALL pmci_parent_datatrans( child_to_parent )
+
+       ELSEIF( TRIM( nesting_datatransfer_mode ) == 'mixed' )  THEN
+
+          CALL pmci_parent_datatrans( parent_to_child )
+          CALL pmci_child_datatrans( parent_to_child )
+
+          CALL pmci_parent_datatrans( child_to_parent )
+          CALL pmci_child_datatrans( child_to_parent )
 
        ENDIF
@@ -3173,12 +3208,12 @@
 
 
- SUBROUTINE pmci_server_datatrans( direction )
+ SUBROUTINE pmci_parent_datatrans( direction )
 
     IMPLICIT NONE
 
-    INTEGER(iwp),INTENT(IN) ::  direction   !:
+    INTEGER(iwp), INTENT(IN) ::  direction   !:
 
 #if defined( __parallel )
-    INTEGER(iwp) ::  client_id   !:
+    INTEGER(iwp) ::  child_id    !:
     INTEGER(iwp) ::  i           !:
     INTEGER(iwp) ::  j           !:
@@ -3191,18 +3226,18 @@
 
 
-    DO  m = 1, SIZE( PMC_Server_for_Client )-1
-       client_id = PMC_Server_for_Client(m)
+    DO  m = 1, SIZE( pmc_parent_for_child ) - 1
+       child_id = pmc_parent_for_child(m)
        
-       IF ( direction == server_to_client )  THEN
-          CALL cpu_log( log_point_s(71), 'pmc server send', 'start' )
-          CALL pmc_s_fillbuffer( client_id )
-          CALL cpu_log( log_point_s(71), 'pmc server send', 'stop' )
+       IF ( direction == parent_to_child )  THEN
+          CALL cpu_log( log_point_s(71), 'pmc parent send', 'start' )
+          CALL pmc_s_fillbuffer( child_id )
+          CALL cpu_log( log_point_s(71), 'pmc parent send', 'stop' )
        ELSE
 !
-!--       Communication from client to server
-          CALL cpu_log( log_point_s(72), 'pmc server recv', 'start' )
-          client_id = pmc_server_for_client(m)
-          CALL pmc_s_getdata_from_buffer( client_id )
-          CALL cpu_log( log_point_s(72), 'pmc server recv', 'stop' )
+!--       Communication from child to parent
+          CALL cpu_log( log_point_s(72), 'pmc parent recv', 'start' )
+          child_id = pmc_parent_for_child(m)
+          CALL pmc_s_getdata_from_buffer( child_id )
+          CALL cpu_log( log_point_s(72), 'pmc parent recv', 'stop' )
 
 !
@@ -3234,9 +3269,9 @@
 
 #endif
- END SUBROUTINE pmci_server_datatrans
-
-
-
- SUBROUTINE pmci_client_datatrans( direction )
+ END SUBROUTINE pmci_parent_datatrans
+
+
+
+ SUBROUTINE pmci_child_datatrans( direction )
 
     IMPLICIT NONE
@@ -3258,5 +3293,5 @@
     IF ( cpl_id > 1 )  THEN
 !
-!--    Client domain boundaries in the server indice space.
+!--    Child domain boundaries in the parent indice space.
        icl = coarse_bound(1)
        icr = coarse_bound(2)
@@ -3264,9 +3299,9 @@
        jcn = coarse_bound(4)
 
-       IF ( direction == server_to_client )  THEN
-
-          CALL cpu_log( log_point_s(73), 'pmc client recv', 'start' )
+       IF ( direction == parent_to_child )  THEN
+
+          CALL cpu_log( log_point_s(73), 'pmc child recv', 'start' )
           CALL pmc_c_getbuffer( )
-          CALL cpu_log( log_point_s(73), 'pmc client recv', 'stop' )
+          CALL cpu_log( log_point_s(73), 'pmc child recv', 'stop' )
 
           CALL cpu_log( log_point_s(75), 'pmc interpolation', 'start' )
@@ -3276,12 +3311,12 @@
        ELSE
 !
-!--       direction == client_to_server
+!--       direction == child_to_parent
           CALL cpu_log( log_point_s(76), 'pmc anterpolation', 'start' )
           CALL pmci_anterpolation
           CALL cpu_log( log_point_s(76), 'pmc anterpolation', 'stop' )
 
-          CALL cpu_log( log_point_s(74), 'pmc client send', 'start' )
+          CALL cpu_log( log_point_s(74), 'pmc child send', 'start' )
           CALL pmc_c_putbuffer( )
-          CALL cpu_log( log_point_s(74), 'pmc client send', 'stop' )
+          CALL cpu_log( log_point_s(74), 'pmc child send', 'stop' )
 
        ENDIF
